import java.util.*;

public class BaumTesten {
  
  public static void main(String[] args) {    
    // Daten einlesen und in Trainings- und Testdaten aufteilen
    Datenliste trainingsdaten = new Datenliste("../iris.csv");
    int gesamt = trainingsdaten.getAnzahlElemente();
    Datenliste testdaten = new Datenliste(trainingsdaten.getMerkmale(), trainingsdaten.getKlassen());
    for (int i=0; i<(0.2 * gesamt); i++) { 
      int nr = (int)(Math.random()*trainingsdaten.getAnzahlElemente());
      Datenelement test = trainingsdaten.getElement(nr);
      testdaten.hinzufuegen(test);
      trainingsdaten.entfernen(test);
    }
    
    // Baum bzw. Bume erzeugen und ausgeben
    Baum baum_1 = new Baum(trainingsdaten);
    Baum baum_2 = new Baum(trainingsdaten, 3);
    System.out.println(baum_1);
    System.out.println(baum_2);
    
    // Baum bzw. Bume auf Test- (und ggf. Trainings-)daten testen
    System.out.println(test(baum_1, testdaten));
    System.out.println(test(baum_2, testdaten));
  }
  
  // bestimmt den Anteil falsch klassifizierter Daten
  private static String test(Baum baum, Datenliste daten) {
    int richtig = 0;
    int falsch = 0;
    for (int i=0; i<daten.getAnzahlElemente(); i++) {
      Datenelement aktuell = daten.getElement(i);
      if (baum.klassifiziere(aktuell).equals(aktuell.getKlasse())) {
        richtig++;
      }
      else {
        falsch++;
      }
    }
    return "richtig klassifiziert: "+richtig+" ("+(100.0*richtig)/daten.getAnzahlElemente()+"%), falsch klassifiziert: "+falsch+" ("+(100.0*falsch)/daten.getAnzahlElemente()+"%)";
  }
  
}
